#ifndef DFA
#define DFA

#include <stdbool.h>

typedef unsigned char uchar;

typedef struct object * Object;

struct dfaOps {
  void (*init) (Object); /*put DFA into its initial state*/
  bool (*final) (Object);
  void (*step) (Object, uchar);
};

struct object {
  struct dfaOps * ops;
  /*internal state goes here*/
};

#endif
