#include "surelyMalloc.h"
#include "TrueFalse.h"

typedef struct tf_rep {
  struct dfaOps * ops;
  bool tf;
} * TF;

void tf_init (Object s) { 
  ((TF)s) -> tf = false;
}

bool tf_final (Object s) {
  return (((TF)s)->tf);
}

void tf_step (Object s, uchar c) {
  ((TF)s)->tf = (c == '0');
}

struct dfaOps tfops = {tf_init, tf_final, tf_step};

Object make_TrueFalse(void) {
  TF s;
  s = (TF) surely_malloc (sizeof (struct tf_rep));
  s->ops = &tfops;
  s->tf = false;
  return ((Object) s);
}
