#include "StaticWeekdays.h"

enum {Mon, Tue, Wed, Thu, Fri, Sat, Sun} day;

void st_weekday_init () { 
  day = Mon;
}

bool st_weekday_final () {
  return (day == Sun);
}

void st_weekday_step (uchar c) {
  if (c != 'n') { return; }
  switch (day) {
  case Mon: { day = Tue; return; }
  case Tue: { day = Wed; return; }
  case Wed: { day = Thu; return; }
  case Thu: { day = Fri; return; }
  case Fri: { day = Sat; return; }
  case Sat: { day = Sun; return; }
  case Sun: { day = Mon; return; }
  default: { return; }
  }
}

struct staticOps st_weekday_ops = {st_weekday_init, st_weekday_final, st_weekday_step};

StaticOps make_StaticWeekdays(void) {
  return (&st_weekday_ops);
}
